package grim3212.mc.doubledoor;

import net.minecraft.block.Block;
import net.minecraft.block.BlockDoor;
import net.minecraft.block.material.Material;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.world.World;

public class BlockDoorBaM extends BlockDoor {
	public BlockDoorBaM(int par1, Material par2Material) {
		super(par1, par2Material);
		disableStats();
	}

	private void activateDoubleDoor(World par1World, int par2, int par3, int par4, EntityPlayer par5EntityPlayer, boolean isPowered) {
		int meta = getFullMetadata(par1World, par2, par3, par4);

		int coordOffset = (meta & 0x10) != 0 ? -1 : 1;
		int coordX;
		int coordZ;
		switch (getDoorOrientation(par1World, par2, par3, par4)) {
		case 0:
			coordX = par2;
			coordZ = par4 + coordOffset;
			break;
		case 1:
			coordX = par2 - coordOffset;
			coordZ = par4;
			break;
		case 2:
			coordX = par2;
			coordZ = par4 - coordOffset;
			break;
		case 3:
			coordX = par2 + coordOffset;
			coordZ = par4;
			break;
		default:
			return;
		}

		int neighbourBlockID = par1World.getBlockId(coordX, par3, coordZ);
		if (this.blockMaterial == Material.iron) {
			if (neighbourBlockID == Block.doorIron.blockID)
				;
		} else if (neighbourBlockID != Block.doorWood.blockID)
			return;

		if ((getDoorOrientation(par1World, par2, par3, par4) != getDoorOrientation(par1World, coordX, par3, coordZ)) || ((getFullMetadata(par1World, par2, par3, par4) & 0x10) == (getFullMetadata(par1World, coordX, par3, coordZ) & 0x10))) {
			return;
		}

		if ((meta & 0x4) == (getFullMetadata(par1World, coordX, par3, coordZ) & 0x4))
			return;

		if (isPowered)
			onPoweredBlockChange(par1World, coordX, par3, coordZ, (meta & 0x4) != 0);
		else
			onBlockActivated(par1World, coordX, par3, coordZ, par5EntityPlayer, 0, 0.0F, 0.0F, 0.0F);
	}

	public boolean onBlockActivated(World par1World, int par2, int par3, int par4, EntityPlayer par5EntityPlayer, int par6, float par7, float par8, float par9) {
		if (super.onBlockActivated(par1World, par2, par3, par4, par5EntityPlayer, par6, par7, par8, par9)) {
			activateDoubleDoor(par1World, par2, par3, par4, par5EntityPlayer, false);
			return true;
		}

		return false;
	}

	public void onPoweredBlockChange(World par1World, int par2, int par3, int par4, boolean par5) {
		super.onPoweredBlockChange(par1World, par2, par3, par4, par5);

		int meta = getFullMetadata(par1World, par2, par3, par4);
		boolean flag = (meta & 0x4) != 0;

		if (flag == par5) {
			activateDoubleDoor(par1World, par2, par3, par4, (EntityPlayer) null, true);
		}
	}
}