package grim3212.mc.doubledoor;

import net.minecraft.block.Block;
import net.minecraft.block.BlockFenceGate;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.world.World;

public class BlockFenceGateBaM extends BlockFenceGate {
	public BlockFenceGateBaM(int par1) {
		super(par1);
	}

	private void activateDoubleFence(World par1World, int par2, int par3, int par4, EntityPlayer par5EntityPlayer, boolean isPowered) {
		int meta = par1World.getBlockMetadata(par2, par3, par4);
		int meta_up = par1World.getBlockMetadata(par2, par3 + 1, par4);
		int meta_down = par1World.getBlockMetadata(par2, par3 - 1, par4);

		boolean is_open = isFenceGateOpen(meta);
		boolean is_open_up = isFenceGateOpen(meta_up);
		boolean is_open_down = isFenceGateOpen(meta_down);

		int orientation = getDirection(meta) & 0x1;
		int orientation_up = getDirection(meta_up) & 0x1;
		int orientation_down = getDirection(meta_down) & 0x1;

		if ((par1World.getBlockId(par2, par3 + 1, par4) == this.blockID) && (orientation == orientation_up) && (is_open != is_open_up)) {
			if (isPowered)
				onPoweredBlockChange(par1World, par2, par3 + 1, par4);
			else {
				onBlockActivated(par1World, par2, par3 + 1, par4, par5EntityPlayer, 0, 0.0F, 0.0F, 0.0F);
			}
		}
		if ((par1World.getBlockId(par2, par3 - 1, par4) == this.blockID) && (orientation == orientation_down) && (is_open != is_open_down)) {
			if (isPowered)
				onPoweredBlockChange(par1World, par2, par3 - 1, par4);
			else
				onBlockActivated(par1World, par2, par3 - 1, par4, par5EntityPlayer, 0, 0.0F, 0.0F, 0.0F);
		}
	}

	public boolean onBlockActivated(World par1World, int par2, int par3, int par4, EntityPlayer par5EntityPlayer, int par6, float par7, float par8, float par9) {
		boolean was_open = isFenceGateOpen(par1World.getBlockMetadata(par2, par3, par4));

		super.onBlockActivated(par1World, par2, par3, par4, par5EntityPlayer, par6, par7, par8, par9);

		if (was_open != isFenceGateOpen(par1World.getBlockMetadata(par2, par3, par4))) {
			activateDoubleFence(par1World, par2, par3, par4, par5EntityPlayer, false);
		}

		return true;
	}

	public void onPoweredBlockChange(World par1World, int par2, int par3, int par4) {
		int meta = par1World.getBlockMetadata(par2, par3, par4);

		if (isFenceGateOpen(meta)) {
			par1World.setBlockMetadataWithNotify(par2, par3, par4, meta & 0xFFFFFFFB, 2);
		} else {
			par1World.setBlockMetadataWithNotify(par2, par3, par4, meta | 0x4, 2);
		}

		par1World.playAuxSFXAtEntity((EntityPlayer) null, 1003, par2, par3, par4, 0);

		activateDoubleFence(par1World, par2, par3, par4, (EntityPlayer) null, true);
	}

	public void onNeighborBlockChange(World par1World, int par2, int par3, int par4, int par5) {
		if ((!par1World.isRemote) && (par5 > 0) && (Block.blocksList[par5].canProvidePower())) {
			boolean was_open = isFenceGateOpen(par1World.getBlockMetadata(par2, par3, par4));

			super.onNeighborBlockChange(par1World, par2, par3, par4, par5);

			if (was_open != isFenceGateOpen(par1World.getBlockMetadata(par2, par3, par4))) {
				activateDoubleFence(par1World, par2, par3, par4, (EntityPlayer) null, true);
			}
		} else {
			super.onNeighborBlockChange(par1World, par2, par3, par4, par5);
		}
	}
}