package grim3212.mc.doubledoor;

import net.minecraft.block.BlockTrapDoor;
import net.minecraft.block.material.Material;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.world.World;

public class BlockTrapDoorBaM extends BlockTrapDoor {
	private static final NeighbourBlocks[] _neighbour_blocks = { new NeighbourBlocks(new RelBlockCoord(0, -1), new RelBlockCoord(1, 0), new RelBlockCoord(-1, 0)), new NeighbourBlocks(new RelBlockCoord(0, 1), new RelBlockCoord(-1, 0), new RelBlockCoord(1, 0)), new NeighbourBlocks(new RelBlockCoord(-1, 0), new RelBlockCoord(0, -1), new RelBlockCoord(0, 1)), new NeighbourBlocks(new RelBlockCoord(1, 0), new RelBlockCoord(0, 1), new RelBlockCoord(0, -1)) };

	public BlockTrapDoorBaM(int par1, Material par2Material) {
		super(par1, par2Material);
		disableStats();
	}

	private boolean IsValidNeighbour(World par1World, int source_x, int source_y, int source_z, int neighbour_x, int neighbour_y, int neighbour_z) {
		int meta_source = par1World.getBlockMetadata(source_x, source_y, source_z);
		int meta_neighbour = par1World.getBlockMetadata(neighbour_x, neighbour_y, neighbour_z);

		if ((this.blockID == par1World.getBlockId(neighbour_x, neighbour_y, neighbour_z)) && ((meta_source & 0x8) == (meta_neighbour & 0x8))) {
			return true;
		}

		return false;
	}

	private void activateDoubleTrap(World par1World, int par2, int par3, int par4, EntityPlayer par5EntityPlayer, boolean isPowered, boolean include_left_right) {
		int meta = par1World.getBlockMetadata(par2, par3, par4);
		NeighbourBlocks neighbour_blocks = _neighbour_blocks[(meta & 0x3)];

		int coord_x = par2 + neighbour_blocks.counterpart.x;
		int coord_z = par4 + neighbour_blocks.counterpart.z;

		if ((IsValidNeighbour(par1World, par2, par3, par4, coord_x, par3, coord_z)) && ((par1World.getBlockMetadata(coord_x, par3, coord_z) & 0x4) != (meta & 0x4))) {
			if (isPowered)
				MyOnPoweredBlockChange(par1World, coord_x, par3, coord_z, (meta & 0x4) != 0, false);
			else {
				MyOnBlockActivated(par1World, coord_x, par3, coord_z, par5EntityPlayer, 0, 0.0F, 0.0F, 0.0F, false);
			}

		}

		if (include_left_right) {
			int left_x = par2 + neighbour_blocks.left.x;
			int left_z = par4 + neighbour_blocks.left.z;
			int right_x = par2 + neighbour_blocks.right.x;
			int right_z = par4 + neighbour_blocks.right.z;

			if ((!IsValidNeighbour(par1World, par2, par3, par4, left_x, par3, left_z)) && (IsValidNeighbour(par1World, par2, par3, par4, right_x, par3, right_z))) {
				left_x = right_x + neighbour_blocks.right.x;
				left_z = right_z + neighbour_blocks.right.z;
			} else if ((!IsValidNeighbour(par1World, par2, par3, par4, right_x, par3, right_z)) && (IsValidNeighbour(par1World, par2, par3, par4, left_x, par3, left_z))) {
				right_x = left_x + neighbour_blocks.left.x;
				right_z = left_z + neighbour_blocks.left.z;
			}

			if ((IsValidNeighbour(par1World, par2, par3, par4, left_x, par3, left_z)) && ((par1World.getBlockMetadata(left_x, par3, left_z) & 0x4) != (meta & 0x4))) {
				if (isPowered)
					MyOnPoweredBlockChange(par1World, left_x, par3, left_z, (meta & 0x4) != 0, false);
				else {
					MyOnBlockActivated(par1World, left_x, par3, left_z, par5EntityPlayer, 0, 0.0F, 0.0F, 0.0F, false);
				}
			}
			if ((IsValidNeighbour(par1World, par2, par3, par4, right_x, par3, right_z)) && ((par1World.getBlockMetadata(right_x, par3, right_z) & 0x4) != (meta & 0x4))) {
				if (isPowered)
					MyOnPoweredBlockChange(par1World, right_x, par3, right_z, (meta & 0x4) != 0, false);
				else
					MyOnBlockActivated(par1World, right_x, par3, right_z, par5EntityPlayer, 0, 0.0F, 0.0F, 0.0F, false);
			}
		}
	}

	public boolean onBlockActivated(World par1World, int par2, int par3, int par4, EntityPlayer par5EntityPlayer, int par6, float par7, float par8, float par9) {
		return MyOnBlockActivated(par1World, par2, par3, par4, par5EntityPlayer, par6, par7, par8, par9, true);
	}

	public boolean MyOnBlockActivated(World par1World, int par2, int par3, int par4, EntityPlayer par5EntityPlayer, int par6, float par7, float par8, float par9, boolean include_left_right) {
		boolean was_open = isTrapdoorOpen(par1World.getBlockMetadata(par2, par3, par4));

		boolean ret = super.onBlockActivated(par1World, par2, par3, par4, par5EntityPlayer, par6, par7, par8, par9);

		if (was_open != isTrapdoorOpen(par1World.getBlockMetadata(par2, par3, par4))) {
			activateDoubleTrap(par1World, par2, par3, par4, par5EntityPlayer, false, include_left_right);
		}

		return ret;
	}

	public void onPoweredBlockChange(World par1World, int par2, int par3, int par4, boolean par5) {
		MyOnPoweredBlockChange(par1World, par2, par3, par4, par5, true);
	}

	public void MyOnPoweredBlockChange(World par1World, int par2, int par3, int par4, boolean par5, boolean include_left_right) {
		super.onPoweredBlockChange(par1World, par2, par3, par4, par5);

		boolean flag = isTrapdoorOpen(par1World.getBlockMetadata(par2, par3, par4));

		if (flag == par5) {
			activateDoubleTrap(par1World, par2, par3, par4, (EntityPlayer) null, true, include_left_right);
		}
	}

	private static class NeighbourBlocks {
		public final BlockTrapDoorBaM.RelBlockCoord counterpart;
		public final BlockTrapDoorBaM.RelBlockCoord left;
		public final BlockTrapDoorBaM.RelBlockCoord right;

		public NeighbourBlocks(BlockTrapDoorBaM.RelBlockCoord cp, BlockTrapDoorBaM.RelBlockCoord l, BlockTrapDoorBaM.RelBlockCoord r) {
			this.counterpart = cp;
			this.left = l;
			this.right = r;
		}
	}

	private static class RelBlockCoord {
		public final int x;
		public final int z;

		public RelBlockCoord(int new_x, int new_z) {
			this.x = new_x;
			this.z = new_z;
		}
	}
}